#! /usr/bin/perl -w

# takes output of fdupes and processes
# use as
# fdupes -rnS Dir/To/Check > dir.dups
# ./summarizeDups.pl < dir.dups

my $VERSION = '1.0';

my $totalSize = 0;
my $totalCount = 0;
my $numSets = 0;
my $totalSavings = 0;
my %setCounts;
my %setSavings;

while ( $line = <> ) {
   if ( $line =~ m/^(\d+).*bytes each:/ ) {
      $numSets++;
      $size = $1;
      $count = 0;
      while ( ( $line = <> ) !~ m/^$/ ) {
         $count++;
      }
      $totalSavings += $size * ( $count-1);
      $totalSize += $size * $count;
      $totalCount += $count;
      $setCounts{$count}++;
      $setSavings{$count} += $size * ( $count-1 );
   }
}

printf ( "Found %d files which were duplicated, resulting in a total of %d copies, for a total of %0.2f megabytes\n", $numSets, $totalCount, $totalSize/1024/1024 );
printf ( "If the %d duplicates were removed, a total of %0.2f megabytes could be saved\n", $totalCount-$numSets, $totalSavings/1024/1024 );
print "The range of duplication follows:\nDuplicates\tInstances\tSavings\n";
foreach my $count ( sort {$a<=>$b} keys %setCounts ) {
   printf ("%10d\t%9d\t%7.2f\n", $count, $setCounts{$count}, $setSavings{$count}/1024/1024);
}  


1;
